//+------------------------------------------------------------------+
//|                                      Hodrick Prescott Filter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyright mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers    1
#property indicator_color1     Red

//
//
//
//
//

#import "Hodrick-Prescott filter.dll"
   double hpFilter(double& sourceArray[], int sourceIsSeries, double& targetArray[], int targetIsSeries, double lambda, int bars);
#import
extern int FilterPeriod = 25;
extern int Price        = PRICE_CLOSE;

//
//
//
//
//

double hp[];
double prices[];
double Lambda;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define pi 3.141592653589793238462643383279502884197169399375105820974944592
int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,hp);
   SetIndexBuffer(1,prices);
      Lambda=0.0625/MathPow(MathSin(pi/FilterPeriod),4);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = MathMin(MathMax(FilterPeriod,Bars-counted_bars),Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)  prices[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
                            hpFilter(prices,true,hp,true,Lambda,Bars);
   return(0);
}

